import request, { postBlob, getBlob, handleImport } from '@/utils/request'

export function getList(params) {
  return request({
    url: '/admin/user/mch/list',
    method: 'get',
    params
  })
}

export function addAccount(params) {
  return request({
    url: '/admin/user/addCompanyWechat',
    method: 'post',
    data: params
  })
}

export function getDetail(params) {
  return request({
    url: '/admin/user/detail',
    method: 'get',
    params
  })
}

export function resetPassword(params) {
  return request({
    url: '/admin/user/password/reset',
    method: 'post',
    params
  })
}

// 更改账户状态
export function changeAccountStatus(params) {
  return request({
    url: '/admin/user/status/update',
    method: 'post',
    params
  })
}

export function editAccount(params) {
  return request({
    url: '/admin/user/user/updateCompanyWechat',
    method: 'post',
    data: params
  })
}

// 获取模版信息
export function getTemplate(params) {
  return request({
    url: '/admin/company/template/detail',
    method: 'get',
    params
  })
}

// 更改模版信息
export function editTemplate(params) {
  return request({
    url: '/admin/company/template/updateCompanyWithTemplate',
    method: 'post',
    data: params
  })
}